if (window.top === window)
{
    var thisPageLinkObjects = null;
	
	function announceFeedsUpdates()
	{
		safari.self.tab.dispatchMessage("currentSyndicationLinks", thisPageLinkObjects);
	}
    
	// I convert the native "link" node into an object that I can pass out to the global page
	function objectFromLink(theLink)
	{
		var linkObject = new Object();
		
		linkObject.href = theLink.href;
		linkObject.type = theLink.type;
		linkObject.title = theLink.title;
		
		return linkObject;
	}
	
	// Some sites will list feeds with inappropriate or at least less-than-ideal information
	// in the MIME type attribute. We cover some edge cases here that allow to be passed through,
	// where they will successfully open as "feed://" URLs in the browser.
	function isValidFeedLink(theLink)
	{
		var isValid = false;
		
		switch (theLink.type)
		{
			case "application/atom+xml":
			case "application/x.atom+xml":
			case "application/rss+xml":
				// These types do not require other criteria.
				isValid = (theLink.href != null);

			case "text/xml":
			case "application/rdf+xml":
				// These types require a title that has "RSS" in it.
				if (theLink.title && theLink.title.search(/RSS/i) != -1)
				{
					isValid = (theLink.href != null);
				}
        }
		
		return isValid;
	}
	
	function scanForSyndicationFeeds()
    {
        // In case we don't find any, we establish that we have at least tried by setting the 
        // variables to empty instead of null.
		thisPageLinkObjects = []
        
        thisPageLinks = document.getElementsByTagName("link");
        
        var shouldAnnounce = false;
        
        for (thisLinkIndex = 0; thisLinkIndex < thisPageLinks.length; thisLinkIndex++)
        {
            var thisLink = thisPageLinks[thisLinkIndex];
            var thisLinkRel = thisLink.getAttribute("rel");
            if (thisLinkRel == "alternate")
            {
				if (isValidFeedLink(thisLink))
				{
					thisPageLinkObjects.push(objectFromLink(thisLink));
                    shouldAnnounce = true;
                }                
            }
        }
        
        if (shouldAnnounce == true)
        {
			announceFeedsUpdates();
        }
    }

    safari.self.addEventListener("message", function(event)
    {
        if (event.name == "globalPageNeedsSyndicationLinks")
        {
			announceFeedsUpdates();
        }
    }, false);
    
    scanForSyndicationFeeds();
}